
local json = require("json")
local utils = require("utils")
local const = require("const")
local pl_pretty = require("pl.pretty")
local utils = require("utils")
local pl_dir = require("pl.dir")
local pl_path = require("pl.path")
local pl_file = require("pl.file")
local resty_string = require("resty.string")


local request_method = ngx.var.request_method

if (not utils.check_permission("LogManage")) then
    utils.error_exit(403)
end

if ("GET" == request_method) then
    local args = ngx.req.get_uri_args()
    if (nil == args) then
        utils.error_exit(400, "invalid parameter")
    end

    sub_path = args["FilePath"]
    if (nil == sub_path) then
        utils.error_exit(400, "invalid parameter")
    end

    -- get root path
    ok, msg_dir = utils.get_data(const.data_key.logger.dir)
    if ((not ok) or (not msg_dir)) then 
        utils.log_error('get log root path failed' .. msg_dir)
        utils.error_exit(500, 'get log root path failed')
    end

    local root_path = msg_dir

    res = {}
    res["List"] = {}
    path = root_path .. '/' .. sub_path
    path = pl_path.normpath(path)
    if (not pl_path.exists(path)) then
        utils.error_exit(400, "unknow path")
    end

    file = io.open(path, 'r') 
    data = file:read("*a")
    file:close()

    ngx.say(data)
    ngx.exit(200)
end

utils.error_exit(400, "unsupported request method")
------ EOF ------
