# -*- coding: utf-8 -*-
import smtplib, os
import zipfile
from email.mime.text import MIMEText
from email.mime.multipart import MIMEMultipart
from email.mime.application import MIMEApplication
from email.header import Header

# 用于发送邮件的邮箱，修改成您自己的邮箱
sender_email_address = 'YourMailbox@163.com'
# 要发往的邮箱，用逗号分隔，此处推荐加入发送者邮箱
receivers_email_address = ['DestMailbox1@qq.com', 'DestMailbox2@163.com', sender_email_address]
# 用于发送邮件的邮箱的密码。修改成自己的邮箱的密码。
# 如使用QQ邮箱，需要先登录QQ邮箱 => 设置 => 账户 => 开启POP3/SMTP服务 => 密码填入生成的“授权码”。
sender_email_password = 'Pass**word'
# 修改成您自己邮箱的smtp服务器地址，可以直接是IP地址，163邮箱不需要修改此值。
smtp_server_host = 'smtp.163.com'
# 修改成自己邮箱的smtp服务器监听的端口，默认为25
smtp_server_port = 25
# 要发送的邮件主题
mail_subject = 'Link-iot-edge Test Mail'


def dfs_get_zip_file(input_path, result):
    files = os.listdir(input_path)
    for file in files:
        if os.path.isdir(input_path + '/' + file):
            dfs_get_zip_file(input_path + '/' + file, result)
        else:
            result.append(input_path + '/' + file)


def zip_path(input_path, output_path, output_name):
    f = zipfile.ZipFile(output_path + '/' + output_name, 'w', zipfile.ZIP_DEFLATED)
    filelists = []
    dfs_get_zip_file(input_path, filelists)
    for file in filelists:
        f.write(file)
    f.close()
    return output_path + "/" + output_name


def send_email_by_smtp(host, username, passwd, receivers, subject, content):
    ret = False
    content_type = 1
    attach_content = ''
    # 将event作为要发送的邮件内容
    mail_content = content
    # 如果event为文件或者目录，将文件或者打包后的目录作为附件发送
    if True == os.access(content, os.F_OK):
        if True == os.path.isdir(content):
            content_type = 3
            file_name = zip_path(mail_content, '/linkedge/run', 'attachment.zip')
            attachment_name = 'attachment.zip'
        else:
            content_type = 2
            file_name = content
            attachment_name = os.path.basename(content)

    # 邮件对象，用于构建邮件
    message = MIMEMultipart()
    message.attach(MIMEText(mail_content, 'plain', 'utf-8'))
    # 设置发件人（声称的）
    message["From"] = Header(username, "utf-8")
    # 设置收件人（声称的）
    message["To"] = ",".join(receivers)
    # 设置邮件主题
    if 0 < len(subject):
        message["Subject"] = Header(subject, "utf-8")
    else:
        message["Subject"] = Header(mail_subject, "utf-8")

    # 添加附件
    if 3 == content_type or 2 == content_type:
        try:
            with open(file_name, "rb") as fd:
                attach_content = fd.read()
        except:
            print("Open file {} failed.".format(file_name))
        attach_obj = MIMEApplication(attach_content)
        attach_obj.add_header('Content-Disposition', 'attachment', filename=attachment_name)
        message.attach(attach_obj)

    # 连接smtp服务器
    email_client = smtplib.SMTP(host, smtp_server_port)
    email_client.starttls()
    # 使能下面这行代码会显示更详细的调试信息
    # email_client.set_debuglevel(1)
    try:
        # 验证邮箱及密码是否正确
        email_client.login(username, passwd)
        print("SMTP - Login success.")
    except:
        print("SMTP - Login failed. Username or password not correct or another problem occur.")
    else:
        try:
            # 发送邮件
            email_client.sendmail(username, receivers, message.as_string())
            ret = True
        except:
            print("SMTP - Sendmail failed.")
            ret = False
    finally:
        # 关闭连接
        email_client.close()

    if 3 == content_type:
        os.remove(file_name)
    return ret


def handler(event, context):
    print("event:", event)
    print("content:", context)
    try:
        subject_user = str(context['invokerContext']['custom']['data'])
    except:
        print("Get context['invokerContext']['custom']['data'] failed.")
        subject_user = str(context)

    ret = send_email_by_smtp(smtp_server_host, sender_email_address, sender_email_password, receivers_email_address,
                             subject_user, event)
    if ret:
        print("SMTP - Message has been successfully sent!")
        return 'Success'
    else:
        print("SMTP - Email sent failed!")
        return 'Failed'
